import { jsx as _jsx } from "react/jsx-runtime";
import { useMemo } from "react";
import { createAutocompleteAddressApiClient } from "./infrastructure/dawa/create-autocomplete-address-api-client";
import { configuration, configure } from "./configuration/configure";
import { createAddressTextNodeTreeService } from "./infrastructure/create-address-text-node-tree-service";
import { useTextNodeTree } from "./core/text-node-search/useTextNodeTree";
import TextNodeSearchInput from "./core/text-node-search/TextNodeSearchInput/TextNodeSearchInput";
import { createTextNodeTreeServiceDebounceDecorator } from "./infrastructure/create-text-node-tree-service-debounce-decorator";
function DawaAutocompleteAddressInput({ addressObserver, configurationOverride }) {
    configure(configurationOverride);
    const service = useMemo(() => {
        return createTextNodeTreeServiceDebounceDecorator(createAddressTextNodeTreeService(createAutocompleteAddressApiClient()));
    }, []);
    const textNodeTree = useTextNodeTree(service, addressObserver);
    return (_jsx(TextNodeSearchInput, { placeholder: configuration.placeholder, isAutoFocus: configuration.isAutoFocus, textNodeTree: textNodeTree }));
}
export default DawaAutocompleteAddressInput;
