var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { configuration } from "../../../configuration/configure";
import EllipsisSpinnerSpans from "../../../shared/EllipsisSpinnerSpans";
const UL_ELEMENT_STYLE = { width: "100%", cursor: "pointer", display: "block" };
function TextNodeSearchInputDropdown({ options, isLoading, activeLiElementIndex, handleChoice }) {
    const STYLING = configuration.styling.textNodeSearchInputDropdown;
    const LI_ELEMENTS_CLASS_NAMES = STYLING.liElementsClassNames;
    const getLiElementClassNames = (i) => {
        let liElementClassNames = LI_ELEMENTS_CLASS_NAMES;
        if (activeLiElementIndex === i) {
            liElementClassNames = liElementClassNames.concat(STYLING.liElementsActiveClassNames);
        }
        return liElementClassNames.join(" ");
    };
    const choose = (e, i) => __awaiter(this, void 0, void 0, function* () {
        var _a;
        e.preventDefault();
        yield handleChoice(i);
        (_a = e.currentTarget) === null || _a === void 0 ? void 0 : _a.classList.remove(...STYLING.liElementsMouseOverClassNames);
    });
    return (_jsx("ul", { 
        // Rather than a list of <Option> elements, <li> and <ul> were chosen because:
        // Using <Option> will cause the dropdown to never show again whenever an option is chosen.
        // Using <Option> offers no way of distinguishing whether an option was chosen or the <Input>'s value was changed.
        className: STYLING.ulElementClassNames.join(" "), style: UL_ELEMENT_STYLE, children: isLoading
            ? _jsxs("li", { className: LI_ELEMENTS_CLASS_NAMES.join(" "), children: [configuration.loadingMessageOnApiClientRequest + " ", _jsx(EllipsisSpinnerSpans, { dotCount: 3, intervalInMilliseconds: 150 })] })
            : options.map((option, i) => {
                return _jsx("li", { className: getLiElementClassNames(i), onMouseOver: (e) => {
                        e.currentTarget.classList.add(...STYLING.liElementsMouseOverClassNames);
                    }, onMouseOut: (e) => {
                        e.currentTarget.classList.remove(...STYLING.liElementsMouseOverClassNames);
                    }, onMouseDown: (e) => __awaiter(this, void 0, void 0, function* () {
                        yield choose(e, i);
                    }), onTouchEnd: (e) => __awaiter(this, void 0, void 0, function* () {
                        yield choose(e, i);
                    }), "aria-selected": activeLiElementIndex === i, role: "option", children: option.presentable.value }, option.query.value);
            }) }));
}
export default TextNodeSearchInputDropdown;
