var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { useEffect, useState } from "react";
function useKeyboardNavigation(length, confirm, change) {
    const [index, setIndex] = useState(0);
    useEffect(() => {
        change(index);
    }, [index]);
    const handleKeyDown = (e) => __awaiter(this, void 0, void 0, function* () {
        switch (e.key) {
            case "ArrowDown": {
                e.preventDefault(); // Fixates caret
                if (index < length - 1) {
                    setIndex((prevState) => prevState + 1);
                }
                break;
            }
            case "ArrowUp": {
                e.preventDefault(); // Fixates caret
                if (index > -1) {
                    setIndex((prevState) => prevState - 1);
                }
                break;
            }
            case "Enter":
            case "Tab": {
                yield confirm(index);
                break;
            }
        }
    });
    const stop = () => {
        setIndex(-1);
    };
    return {
        optionsIndex: index,
        isNavigating: index > -1,
        handleKeyDown,
        stop
    };
}
export default useKeyboardNavigation;
