var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { succeed } from "../../shared/Result";
export function createResultingCaretTextQueryNode(isRoot, isLeaf, getChildren, query, presentable, result) {
    let _children = null;
    return {
        isRoot: isRoot,
        isLeaf: isLeaf,
        getChildren() {
            return __awaiter(this, void 0, void 0, function* () {
                if (this.isLeaf) {
                    return succeed([]);
                }
                if (!_children || _children.type === "failure") {
                    _children = yield getChildren(this);
                }
                return _children;
            });
        },
        query: query,
        presentable: presentable,
        isMatch(value) {
            return presentable.isMatch(value) || query.isMatch(value);
        },
        result: result,
    };
}
