var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { mapSuccess } from "../shared/Result";
import { createToReqDtoMapper } from "./create-to-req-dto-mapper";
import { createFromResDtoMapper } from "./map-res-dto-to-node";
export function createAddressTextNodeTreeService(apiClient) {
    const _toReqDtoMapper = createToReqDtoMapper();
    const _fromResDtoMapper = createFromResDtoMapper();
    function getNodesByCaretText(value, caretIndexInValue, abortController) {
        return __awaiter(this, void 0, void 0, function* () {
            const reqDto = _toReqDtoMapper.mapCaretTextToReqDto(value, caretIndexInValue);
            const resDtosResult = yield apiClient.readAutocompleteAddresses(reqDto, abortController);
            return _mapResDtosToNodes(resDtosResult);
        });
    }
    function getNodesByNode(node) {
        return __awaiter(this, void 0, void 0, function* () {
            const reqDto = _toReqDtoMapper.mapNodeToReqDto(node);
            const resDtosResult = yield apiClient.readAutocompleteAddresses(reqDto);
            return _mapResDtosToNodes(resDtosResult);
        });
    }
    return {
        getNodesByCaretText,
        getNodesByNode
    };
    function _mapResDtosToNodes(resDtosResult) {
        return mapSuccess(resDtosResult, (s) => s.map((dto) => _fromResDtoMapper.mapResDtoToNode(dto, getNodesByNode)));
    }
}
