var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { configuration } from "../configuration/configure";
import { cancelStaleRequest } from "../shared/Result";
export function createTextNodeTreeServiceDebounceDecorator(decoratee) {
    let _abortController = null;
    let _id = 0;
    let _timeoutId = 0;
    let _resolve = null;
    function getNodesByCaretText(value, caretIndexInValue) {
        _abortController === null || _abortController === void 0 ? void 0 : _abortController.abort();
        _abortController = new AbortController();
        const abortController = _abortController;
        const id = ++_id;
        clearTimeout(_timeoutId);
        if (_resolve) {
            _resolve(cancelStaleRequest());
            _resolve = null;
        }
        return new Promise((resolve) => {
            _timeoutId = setTimeout(() => __awaiter(this, void 0, void 0, function* () {
                const result = yield decoratee.getNodesByCaretText(value, caretIndexInValue, abortController);
                if (id < _id) {
                    resolve(cancelStaleRequest());
                    return;
                }
                resolve(result);
            }), configuration.apiRequestTypingDebounceMilliseconds);
            _resolve = resolve;
        });
    }
    return {
        getNodesByCaretText,
        getNodesByNode: decoratee.getNodesByNode
    };
}
