import { jsx as _jsx } from "react/jsx-runtime";
import { useEffect, useState } from "react";
function EllipsisSpinnerSpans({ dotCount = 3, intervalInMilliseconds = 250 }) {
    const [visibleDotIndex, setVisibleDotIndex] = useState(0);
    useEffect(() => {
        const intervalId = window.setInterval(() => {
            setVisibleDotIndex((prev) => (prev + 1) % dotCount);
        }, intervalInMilliseconds);
        return () => clearInterval(intervalId);
    }, [dotCount, intervalInMilliseconds]);
    return (_jsx("div", { style: { display: "inline-block" }, role: "status", "aria-label": "Loading", children: Array.from({ length: dotCount }).map((_, i) => {
            return _jsx("span", { style: i === visibleDotIndex ? { visibility: "visible" } : { visibility: "hidden" }, children: "." }, i);
        }) }));
}
export default EllipsisSpinnerSpans;
