export function succeed(success) {
    return { type: "success", value: success };
}
export function fail(failure) {
    return { type: "failure", value: failure };
}
export function cancel(cancellation) {
    return { type: "cancellation", value: cancellation };
}
export function cancelStaleRequest() {
    return { type: "cancellation", value: { reason: "Stale request." } };
}
export function mapSuccess(result, successMapper) {
    switch (result.type) {
        case "success":
            return succeed(successMapper(result.value));
        case "failure":
            return fail(result.value);
        case "cancellation":
            return cancel(result.value);
    }
}
export function mapFailure(result, failureMapper) {
    switch (result.type) {
        case "success":
            return succeed(result.value);
        case "failure":
            return fail(failureMapper(result.value));
        case "cancellation":
            return cancel(result.value);
    }
}
export function map(result, successMapper, failureMapper, cancellationMapper) {
    switch (result.type) {
        case "success":
            return succeed(successMapper(result.value));
        case "failure":
            return fail(failureMapper(result.value));
        case "cancellation":
            return cancel(cancellationMapper(result.value));
    }
}
